#!PERL_ABSOLUTE_PATH
#
#This file is part of NNIPF(Version 0.03-beta):SPAM mail filtering software.
#Copyright (C) Toshikazu Wada <twada@ieee.org>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#############################################################################
if (($start=rindex($0,"/")) >-1) {
        $ME=substr($0,$start+1);
        $Cmdpath=substr($0,0,$start);
}else{ $ME=$0; $Cmdpath=".";}
push @INC, "$Cmdpath/CONF", "$Cmdpath/PERL";
require 'conf.pl';
require 'analyze.pl';
require 'header.pl';
use Encode;
use Encode::Guess qw/ shiftjis euc-jp 7bit-jis /;

$DayFrom="0";
$DayTo="1";
$DayFixed=0;

#initialization
 HEADER::bRead($BOUNDARY);

if ($ENV{'REQUEST_METHOD'} eq "POST") {
   read(STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
        @a = split(/&/, $query_string);
        foreach $x (@a) {
                ($name, $value) = split(/=/, $x);
		$name =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		if (($DayFixed eq 0)&&($name eq "DT")) {
			$DayTo=$value;
		}elsif (($DayFixed eq 0)&&($name eq "DF")) {
			$DayFrom=$value;
		}elsif ($name eq "DP") {
			if ($value<8){
			$DayFrom=$value-1;
			$DayTo=$value;
			$DayFixed=1;
			}
		}elsif ($name eq "DIR") {
			$dir=$value;
		}elsif ($value eq "N") {
#### "Normal" Maildir/** -> Maildir/new
			$filename="$MAILDIR/$dir/$name";
			$RCV=HEADER::rvf($filename);
			($OIP, $DIP, $ONAME, $DNAME, $ISHELO)=ANALYZE::components($RCV);
			if ($OIP ne ""){ANALYZE::IpDictAddExclusive($OIP,$GOODIP,$BADIP);}
			if ($dir eq "$TMPNAME") {
			    if ($TOCELLPHONE ne "")
			            {system("cat $filename |$TOCELLPHONE");}
			    $dfilename="$NEW/$name";
			    rename $filename, $dfilename;
			}
		  } elsif ($value eq "S") {
#### "Spam" Maildir/** -> TRASH
			$filename="$MAILDIR/$dir/$name";
			$RCV=HEADER::rvf($filename);
			($OIP, $DIP, $ONAME, $DNAME, $ISHELO)=ANALYZE::components($RCV);
			if ($OIP ne ""){ANALYZE::IpDictAddExclusive($OIP,$BADIP,$GOODIP);}
			$dfilename="$TRASH/$name";
			rename $filename, $dfilename;
		  } elsif ($value eq "R"){
#### "Normal" TRASH -> Maildir/new
			$filename="$TRASH/$name";
			$RCV=HEADER::rvf($filename);
			($OIP, $DIP, $ONAME, $DNAME, $ISHELO)=ANALYZE::components($RCV);
			if ($OIP ne ""){ANALYZE::IpDictAddExclusive($OIP,$GOODIP,$BADIP);}
			if ($TOCELLPHONE ne "")
			     {system("cat $filename |$TOCELLPHONE");}
############# This may be changed################
			$name =~ s/:2,.*//;
#################################################
			$dfilename = "$NEW/$name";
			rename $filename, $dfilename;
		  } elsif ($value eq "A"){
##### "Add" Register Bad or Good Address
			$filename="$MAILDIR/$dir/$name";
			if ($dir =~ /$CURNAME|$TMPNAME/){
			$DICT1=$GOODIP;
			$DICT2=$BADIP;
			}else{
			$DICT1=$BADIP;
			$DICT2=$GOODIP;
			}
			$RCV=HEADER::rvf($filename);
			($OIP, $DIP, $ONAME, $DNAME, $ISHELO)
				=ANALYZE::components($RCV);
			if ($OIP ne ""){
			     ANALYZE::IpDictAddExclusive($OIP,$DICT1,$DICT2);}
		  } elsif ($name eq "MSG"){
 			open(OUTbf,"> $BOUNDARY");
			$value =~ s/\r//;
			print OUTbf $value;
			close(OUTbf);
		        HEADER::bRead($BOUNDARY);
		  } 
	}
}elsif (($ENV{'REQUEST_METHOD'} eq "GET")&&(($QS=$ENV{'QUERY_STRING'}) ne "")) {
# Read specified Mail
    @a = split(/&/, $QS);
    foreach $x (@a) {
                ($name, $value) = split(/=/, $x);
                if ($name eq "FILE") {$filename=$value;}
              }
print <<END_HTML1;
Content-type: text/html

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-2022-jp">
<TITLE>SPAM CONSOLE</TITLE>
</HEAD>
<BODY>
<PRE>
END_HTML1
    $flag=0;
    if (($filename =~ /$CURNAME\//)||
        ($filename =~ /$TMPNAME\//)||
	($filename =~ /$TRASHNAME\//)){ $filename = $MAILDIR . "/" . $filename;$flag=1;}
print $filename;
    if ($flag){
    open(IN,$filename);
    while (<IN>){
        print $_;
    }
    close(IN);
    }
print <<END_HTML2;
</PRE>
</BODY>
</HTML>
END_HTML2
exit;
#################end
}

print <<END_OF_HTML1;
Content-type: text/html

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=Shift_JIS">
<TITLE>SPAM CONSOLE</TITLE>
<meta http-equiv=Refresh content=180>
<meta http-equiv="Pragma" content="no-cache">
</HEAD>
<BODY>
END_OF_HTML1
 print "<TABLE BORDER=0 align=>\n<TR VALIGN=top>\n<TD>\n";
 print "<A HREF=\"./DOC/README-j.html\"> README </A>&nbsp;"; 
 print "<A HREF=\"./DOC/WEB-interface.html\"> WEB-INTERFACE </A>&nbsp;";
 print "<A HREF=\"./DOC/MTAOBhowto.html\"> Received Field </A>";
 print "</TD><TD>";
#Show Boundary File
 print "<form method=\"POST\" action=\"$ME\">\n";
 print "<textarea name=\"MSG\" cols=40 rows=4>\n";
 open(INbf,$BOUNDARY);
 while(<INbf>){ $_ =~ s/\n//; $_ =~ s/[0-9]/9/; print "$_\n"; }
 close(INbf);
 print "</textarea>";
 print "<BR>Boundary FILE";
 print "<input type=submit value=\"UPDATE\">";
 print "</form>";
 print "</TD></TR></TABLE>";


 DirRead("$TMP/",0,1000);
 DirRead("$CUR/",0,1000);
 DirRead("$TRASH/",$DayFrom,$DayTo);

print <<END_OF_HTML2;
</BODY>
</HTML>
END_OF_HTML2

############################################
sub DirRead
{
($dir,$dayfrom, $dayto)=@_;
$endpos=length($dir);
$DIR=$dir;
if (substr($dir,$endpos-1) eq "/") {$DIR=substr($DIR,0,$endpos-1);}
$title=substr($DIR,rindex($DIR,"/")+1);

my %Subj, %Sfrm, %Past, %Date, %Rfrm;
my @msg = ();
my @result = ();

# Init
#
my @Buf;
$now=time();
$Df=$dayfrom*86400;
$Dt=$dayto*86400;

{
my @Result = ( );;

{
my @Msg = ( );
 opendir DH, $dir or die "$dir:$!";
 $count = 0;
 while (my $file = readdir DH) {
  next if $file =~ /^\.{1,2}$/;	
 $Pas = $now-substr($file,0,10);
 if (($Pas > $Df)&&($Pas <= $Dt)) {
  $Msg[$count++]=$file;
 }
 }
 closedir DH;
 @Result= sort { $b cmp $a } @Msg;
}

$count = 0;
foreach $file (@Result) {
    $Pas = $now-substr($file,0,10);
    $filename=$dir . $file;

    if (-e $filename){
    open(IN, $filename);
    ($subject, $date, $from, $Rfrom, $Frm, $lcount)
				=HEADER::HeaderAnalysis(*IN,*Buf);
    close(IN);
# end of header reading
    ($OIP, $DIP, $ONAME, $DNAME, $ISHELO)=ANALYZE::components($Frm);
    $score=ANALYZE::analyze($Frm,0,$BADIP,$GOODIP);
    if (($title ne "$CURNAME")||($OIP ne "")&&
      ( (ANALYZE::IsPrivate($OIP) eq 0)&&
        (ANALYZE::IpDictMatch($OIP,$GOODIP,0) > $PMATCH)||
	(ANALYZE::IpDictMatch($OIP,$BADIP,0) <= $PMATCH))) {
	$Oip{$file}=$OIP; 
	$Past{$file}=$Pas; 
	$Score{$file}=$score;
	$Subj{$file}=$subject; 
	$Date{$file}=$date; 
	$Sfrm{$file}=$from; 
	$Rfrm{$file}=$Frm; 
	$result[$count++]=$file;
    }
   }

 }
}

# ~/Maildir/cur or ~Maildir/tmp
   if ($title =~ /$CURNAME|$TMPNAME/) {
   if ($count>0){
	print "<H4>$title</H4>\n";
	print $#result+1, "items\n";
	print "<form method=\"POST\" action=\"$ME\">";
	print "<input type=\"hidden\" name=\"DIR\" value=\"$title\" >\n";
        print "<input type=submit>";
        print "<input type=reset>";
        print "<TABLE BORDER=4 align=>\n<TR VALIGN=top>\n<TD>\n";
	foreach $i (@result) {
	    ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(substr($i,0,10));
	    $mon += 1;
	    $year+=1900;
	    $Sfrm{$i}=encode('shiftjis', decode('MIME-Header',$Sfrm{$i}));
# This code is for non-mime-encoded From. Should be replaced############
	    if ($Sfrm{$i}=~ /^(.*)(.\$B.*\(B)(.*)$/){
	      $one=$1;$two=$2;$c=$3; $c=~ s/</&lt;/g; $c=~ s/>/&gt;/g;
	      $Sfrm{$i}=sprintf("%s%s%s",$one,$two,$c);
	    }else{
	      $Sfrm{$i}=~ s/</&lt;/g; $Sfrm{$i}=~ s/>/&gt;/g;
	    }
	    $Sfrm{$i}=encode('shiftjis',decode('Guess',$Sfrm{$i}));
##########################################################################
	    if ($Subj{$i}=~ /^=\?/) {$Subj{$i}=encode('shiftjis', decode('MIME-Header',$Subj{$i}));}
 	    if ($Subj{$i} =~ /^\s*$/) {
	    	$Subj{$i} = "**No Title**";
 	    }
	    print "<TR><TD ROWSPAN=4>";
	    print "<input type=\"radio\" name=\"$i\" value=\"S\">Spam<BR>";
   	    if ($title !~ /$CURNAME/) {
	    print "<input type=\"radio\" name=\"$i\" value=\"N\">Nomal<BR>";
	    }
   	    if ($title !~ /$TMPNAME/) {
 	     if (($Oip{$i} ne "")&&
		((ANALYZE::IpDictMatch($Oip{$i},$GOODIP,0) > $PMATCH)
		||(ANALYZE::IpDictMatch($Oip{$i},$BADIP,0) <= $PMATCH))) {
	      print "<input type=\"radio\" name=\"$i\" value=\"A\" checked>AddGIP<BR>";
	     }
            }
	     print "</TD>";
	     if ($Score{$i}>80) { print "<TD ROWSPAN=4 bgcolor=#FF0000>";}
	     elsif ($Score{$i}>50) { print "<TD ROWSPAN=4 bgcolor=#FFFF00>";}
	     else {print "<TD ROWSPAN=4>";}
	    print "$Score{$i}</TD>";
	    print "<TD>$year/$mon/$mday $hour:$min:$sec</TD></TR>";
	    print "<TR><TD>$Sfrm{$i}</TD></TR>";
	    print "<TR><TD><A href=\"$ME?FILE=$title/$i\"> $Subj{$i}</A></TD></TR>";
	    print "<TR><TD>$Rfrm{$i}</TD></TR>";
	    print "</TR>\n";
	}
     print( "</TABLE>");
     print( "</form method>");
    }
   }else{
# TRASH
  print "<H4>$title</H4>\n";
  print $#result+1, "items\n";
  print "<form method=\"POST\" action=\"$ME\">";
  print "<input type=\"hidden\" name=\"DIR\" value=\"$title\" >\n";
        print "Past";

	print "<input type=\"radio\" name=\"DP\" value=\"1\"", ($DayTo eq 1)? "checked":"", ">1";
	print "<input type=\"radio\" name=\"DP\" value=\"2\"", ($DayTo eq 2)? "checked":"", ">2";
	print "<input type=\"radio\" name=\"DP\" value=\"3\"", ($DayTo eq 3)? "checked":"", ">3";
	print "<input type=\"radio\" name=\"DP\" value=\"4\"", ($DayTo eq 4)? "checked":"", ">4";
	print "<input type=\"radio\" name=\"DP\" value=\"5\"", ($DayTo eq 5)? "checked":"", ">5";
	print "<input type=\"radio\" name=\"DP\" value=\"6\"", ($DayTo eq 6)? "checked":"", ">6";
	print "<input type=\"radio\" name=\"DP\" value=\"7\"", ($DayTo eq 7)? "checked":"", ">7";

	print "(<input type=text name=\"DF\" size=2 value=$dayfrom > ";
        print "-<input type=text name=\"DT\" size=2 value=$dayto >)\n";
	print "<input type=\"radio\" name=\"DP\" value=\"8\"",($DayTo >7)? "checked":"", "> Days.";
	print( "<input type=submit>");
	print( "<input type=reset>");

if ($count>0){
        print( "<TABLE BORDER=4>\n<TR VALIGN=top>\n<TD>\n");
	foreach $i (@result) {
	    ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(substr($i,0,10));
	    $mon += 1;
	    $year+=1900;
	    $Sfrm{$i}=encode('shiftjis', decode('MIME-Header',$Sfrm{$i}));
### For non-mime encoded from. Should be replaced #################
	    if ($Sfrm{$i}=~ /^(.*)(.\$B.*\(B)(.*)$/){
	    $one=$1;$two=$2;$c=$3; $c=~ s/</&lt;/g; $c=~ s/>/&gt;/g;
	    $Sfrm{$i}=sprintf("%s%s%s",$one,$two,$c);
	    }else{
	    $Sfrm{$i}=~ s/</&lt;/g; $Sfrm{$i}=~ s/>/&gt;/g;
	    }
	    $Sfrm{$i}=encode('shiftjis',decode('Guess',$Sfrm{$i}));
####################################################################
	    if ($Subj{$i}=~ /^=\?/) {$Subj{$i}=encode('shiftjis', decode('MIME-Header',$Subj{$i}));}
 	    if ($Subj{$i} =~ /^\s*$/) {
	    	$Subj{$i} = "**No Title**";
 	    }
	     print "<TR><TD ROWSPAN=4>";
	     print "<input type=\"radio\" name=\"$i\" value=\"R\">Nomal<BR>";
             if (($Oip{$i} ne "")&&
		 (ANALYZE::IpDictMatch($Oip{$i},$BADIP,0)>$PMATCH)){
             print "<input type=\"radio\" name=\"$i\" value=\"A\" checked>AddBIP<BR>";
	     }
	     print "</TD>";
	     if ($Score{$i}<30) { print "<TD ROWSPAN=4 bgcolor=#FF0000>";}
	     elsif ($Score{$i}<100) { print "<TD ROWSPAN=4 bgcolor=#FFFF00>";}
	     else {print "<TD ROWSPAN=4>";}
	     print "$Score{$i}</TD>";
	    print "<TD>$year/$mon/$mday $hour:$min:$sec</TD></TR>";
	    print "<TR><TD>$Sfrm{$i}</TD></TR>";
 	    $filename=$dir . $i;
	     print "<TR><TD><A href=\"$ME?FILE=$title/$i\"> $Subj{$i}</A></TD></TR>";
	     print "<TR><TD>$Rfrm{$i}</TD></TR>";
	}
 print( "</TABLE>");
   }
 print( "</form method>");
 }
}
