#############
package HEADER;
#
#This file is part of NNIPF(Version 0.03-beta):SPAM mail filtering software.
#Copyright (C) Toshikazu Wada <twada@ieee.org>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
sub HeaderAnalysis{
(*INt, *Buf) = @_;
my $subject="";
my $date ="";
my $from ="";
my $Rfrom ="";
my $Frm ="";
my $lcount=0;
# Init
 $hflag=1;
 $Rflag = 0;
# if ($filename eq "") {INt = STDIN;}
# else{ open(INt, $filename);}
 while (($hflag)&&($line = <INt>)){
        $Buf[$lcount++] = $line;
        $line =~ s/\n//;
# When Empty line is read
        if (length($line) eq 0) {$hflag = 0; }
# Make each Field into a single line
        if ($line =~ /^([A-z0-9\-]*): /) {
                if ($Rflag eq 1) {
                        if ($Rline =~ /^Received: (.*)$/) {
                                ($Rfrom,$By)=ReceivedFrom($1);
				if (($By)&&(Checkb($By))) {$Frm=$Rfrom;}
                        }else{
        if ($Rline =~ /^From: /) {$from = substr($Rline,6);}
        if ($Rline =~ /^Date: /) {$date = substr($Rline,6);}
        if ($Rline =~ /^Subject: /) {$subject = substr($Rline,9);}
                        }
                } else {$Rflag=1;}
                $Rline=$line;
        }else{
                if ($Rflag) {
                        $line =~ s/^\s*//g;
                        $Rline = $Rline . $line;
                }
        }
    }
 if ($Frm eq "") {if ($Rfrom) {$Frm=$Rfrom;}else{$Frm="Ok";} }
 $subject =~ s/^\s*$//;
 return ($subject, $date, $from, $Rfrom, $Frm, $lcount);
}

#############
sub ReceivedFrom{
        ($l)=@_;
my $from="";
my $by="";
        if ($l =~ /^from (.*)by (.*)for (.*);(.*)$/ ){
                $from = $1;
                $by = substr($2,0,index($2," with"));
                if ($by =~ /([A-z0-9\.\-_]*) /) {$by = $1;}
                $from =~ s/ *$//;
        }elsif ($l =~ /^from (.*)by (.*);(.*)$/){
                        $from = $1;
                        $by = substr($2,0,index($2," with"));
                        if ($by =~ /([A-z0-9\.\-_]*) /) {$by = $1;}
                $from =~ s/ *$//;
	}
        return ($from,$by);
}
#############
sub bRead{
 ($Dict) = @_;
 @hash = ();
 my $i=0;
 open(INb,$Dict);
 while(<INb>){ $_ =~ s/\n//; $_ =~ s/\r//; $hash[$i++]="$_"; }
 close(INb);
}

#############
sub Checkb {
 ($query) = @_;
 my $i;
 foreach $i (@hash) {
   if ( $query =~ /^$i$/){
		return 1;
	}
 }
 return 0;
}
############
sub DictMatch{
 ($query,$Dict) = @_;
 my $flag=0;
 open(INdict, $Dict);
 while(($x = <INdict>)&&($frag eq 0)) {$x =~ s/\n//;
                  if ($x eq $query) {$frag=1;}
                }
 close(INdict);
 return $frag;
}
############
sub rvf{
 ($fn) = @_;
 my $subject="";
 my $date="";
 my $from="";
 my $Rfrom="";
 my $Frm="";
 my $lcount=0;
 my @Buf;
 open(INtmp, $fn);
 ($subject, $date, $from, $Rfrom, $Frm, $lcount)=HeaderAnalysis(*INtmp,*Buf);
 close(INtmp);
 chomp($Frm);
 return $Frm;
}
1;
