#!PERL_ABSOLUTE_PATH
#
#This file is part of NNIPF(Version 0.03-beta):SPAM mail filtering software.
#Copyright (C) Toshikazu Wada <twada@ieee.org>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#############################################################################
if (($start=rindex($0,"/")) >-1) {
        $ME=substr($0,$start+1);
        $Cmdpath=substr($0,0,$start);
}else{ $ME=$0; $Cmdpath=".";}
require "$Cmdpath/CONF/conf.pl";
require "$Cmdpath/mimer.pl";
require "$Cmdpath/jcode.pl-2.13";
require "$Cmdpath/PERL/analyze.pl";
require "$Cmdpath/PERL/header.pl";

#initialization
 bRead($BOUNDARY);
 $Ratio=-1;

if ($ENV{'REQUEST_METHOD'} eq "POST") {
   read(STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
        @a = split(/&/, $query_string);
        foreach $x (@a) {
                ($name, $value) = split(/=/, $x);
                $name =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
                $value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		if ($name eq "IP") {
			$IP=$value;
			chomp($IP);
			if ($IP =~ /[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+/){
			$Dgip=IpDictMatch($value,$GOODIP,1);
			$Dbip=IpDictMatch($value,$BADIP,1);
			$Ratio=Bratio($Dgip,$Dbip);
			} else{
			$IP="Incorrect IP";
			$Ratio=-1;
			}
        	}
	}
}

print <<END_OF_HTML1;
Content-type: text/html

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=Shift_JIS">
<TITLE>SPAM CONSOLE</TITLE>
<meta http-equiv="Pragma" content="no-cache">
</HEAD>
<BODY>
END_OF_HTML1
  print "<form method=\"POST\" action=\"$ME\">";
  print "IP ADDRESS=<input type=text name=\"IP\" size=16 value=\"$IP\" > ";
  print "SpamDegree = ";
  if ($Ratio >=0) {printf(" %f%%\n", $Ratio*100) ;} else {print "???";}
  print "<input type=submit value=\"CHECK\">";
print <<END_OF_HTML2;
</BODY>
</HTML>
END_OF_HTML2

