#!PERL_ABSOLUTE_PATH
#
#This file is part of NNIPF(Version 0.03-beta):SPAM mail filtering software.
#Copyright (C) Toshikazu Wada <twada@ieee.org>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#############################################################################
#initialization
if (($start=rindex($0,"/")) >-1) {
        $ME=substr($0,$start+1);
        $Cmdpath=substr($0,0,$start);
}else{ $ME=$0; $Cmdpath=".";}
push @INC, "$Cmdpath/CONF", "$Cmdpath/PERL";
require 'conf.pl';
require 'analyze.pl';
require 'header.pl';

{
 HEADER::bRead($BOUNDARY);

if ($#ARGV > -1) {open(IN,$ARGV[0]);}
else{ *IN = *STDIN;}

($subject, $date, $from, $Rfrom, $Frm, $lcount)=HEADER::HeaderAnalysis(*IN,*Buf);
($OIP, $DIP, $ONAME, $DNAME, $ISHELO)=ANALYZE::components($Frm);
 if ($lcount>3) {
 if (ANALYZE::IsPrivate($OIP) ||(($Dgip=ANALYZE::IpDictMatch($OIP,$GOODIP,1)) <= $PMATCH)) {
######### Known GOOD
      if ($Dgip > $PMATCH) {$Dgip=0;}
      chomp($host = `hostname`);
      $filename=sprintf("%s/%ld.%ld.%s",$NEW,time(),$$,$host);
      open(OUT,"> $filename");
	 foreach $i  (@Buf){
	 print $i;
	 print(OUT $i);
	 }
	 while (<IN>) { print $_; print(OUT $_);}
      close(OUT);
 }elsif (($Dbip=ANALYZE::IpDictMatch($OIP,$BADIP,1)) <= $PMATCH) {
######### Known BAD
      chomp($host = `hostname`);
      $name=sprintf("%ld.%ld.%s",time(),$$,$host);
      $filename=sprintf("%s/%s",$TMP,$name);
      open(OUT,"> $filename");
	 foreach $i  (@Buf){
	 print(OUT $i);
	 }
	 while (<IN>) { print(OUT $_);}
      close(OUT);
      $dfilename="$TRASH/$name";
      rename $filename, $dfilename;
 }else{
######### Unknown
      	chomp($host = `hostname`);
      	$name=sprintf("%ld.%ld.%s",time(),$$,$host);
      	$filename=sprintf("%s/%s",$TMP,$name);
      	open(OUT,"> $filename");
	 foreach $i  (@Buf){
	 print(OUT $i);
	 }
	 while (<IN>) { print(OUT $_);}
      	close(OUT);
      if (ANALYZE::Bratio($Dgip,$Dbip)>$T1){
###### May be BAD
        ANALYZE::IpDictAdd($OIP,$BADIP);
      	$dfilename="$TRASH/$name";
      	rename $filename, $dfilename;
      }elsif (ANALYZE::Bratio($Dgip,$Dbip)<$T2) {
###### Almost Known
	$dfilename="$NEW/$name";
      	rename $filename, $dfilename;
      }
 }
 }
if ($#ARGV > -1) {close(IN);}
}
